package com.vendor.loader.util.ssu;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Messages;
import com.vendor.loader.controler.Builder;
import com.vendor.loader.struct.CableMode;
import com.vendor.loader.struct.DbFrontEnd;
import com.vendor.loader.struct.HeadTsPacket;
import com.vendor.loader.struct.PartFile;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.struct.UpgradeInfo;
import com.vendor.loader.struct.ssu.CompatibilityDescriptor;
import com.vendor.loader.struct.ssu.DDBSections;
import com.vendor.loader.struct.ssu.DSMCCMessageHeader;
import com.vendor.loader.struct.ssu.DSMCCSectionHead;
import com.vendor.loader.struct.ssu.DSMCC_SectionInfo;
import com.vendor.loader.struct.ssu.GroupDescription;
import com.vendor.loader.struct.ssu.GroupInfoIndication;
import com.vendor.loader.struct.ssu.ModuleDescription;
import com.vendor.loader.struct.ssu.SsuUpgradeInfo;
import com.vendor.loader.struct.ssu.SubCompatibilityDescriptor;
import com.vendor.loader.util.Crc32;
import com.vendor.loader.util.FileHelper;
import com.vendor.loader.util.FileUtil;
import com.vendor.loader.util.LoaderException;
import com.vendor.loader.util.RandomFileOutputStream;
import com.vendor.loader.util.StringUtil;
import com.vendor.loader.util.ssu.SsuPackageOptions;
import com.vendor.loader.views.LoaderView;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.SubProgressMonitor;

public class SsusaTsPackageBuilder implements Builder {
  public static final int MAGICNUM_SIZE = 4;
  
  public static final String UPGRADE_FILE_NAME = "packer.ts";
  
  public static final int SDTPID = 17;
  
  public static final int SDTTABLEID = 66;
  
  public static final int PATPID = 0;
  
  public static final int PATTABLEID = 0;
  
  public static final int NITPID = 16;
  
  public static final int NITTABLEID = 64;
  
  public static final int TABELINDEX = 5;
  
  public static final int STARTINDICATORINDEX = 1;
  
  public static final int STARTINDICATOR = 4;
  
  public static final int SECTIONSYNTAXINDICATORINDEX = 6;
  
  public static final int CURRENTNEXTINDICATORINDEX = 10;
  
  public static final int PMTTABLEID = 2;
  
  public static final int PMTPIDMIN = 32;
  
  public static final int PMTPIDMAX = 8190;
  
  public static final int CURRENTNEXTINDICATOR = -1;
  
  public static final int SECTIONSYNTAXINDICATOR = -5;
  
  private static final int SIZE_OF_U16 = 2;
  
  private static long g_u32DataTotalLen = 0L;
  
  private static long g_HardwareModel = 1L;
  
  private static long g_softwareModel = 1L;
  
  private static long g_HardwareVersion = 1L;
  
  public static long getG_u32DataTotalLen() {
    return g_u32DataTotalLen;
  }
  
  public static void setG_u32DataTotalLen(long g_u32DataTotalLen) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_u32DataTotalLen = g_u32DataTotalLen;
  }
  
  private static int g_u32DataCrc = 0;
  
  private static short g_u32GroupId;
  
  public static short getG_u32GroupId() {
    return g_u32GroupId;
  }
  
  public static void setG_u32GroupId(short g_u32GroupId) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_u32GroupId = g_u32GroupId;
  }
  
  public static int getG_u32DataCrc() {
    return g_u32DataCrc;
  }
  
  public static void setG_u32DataCrc(int g_u32DataCrc) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_u32DataCrc = g_u32DataCrc;
  }
  
  private static long g_softwareVersion = 16843009L;
  
  public static long getG_softwareVersion() {
    return g_softwareVersion;
  }
  
  public static void setG_softwareVersion(long g_softwareVersion) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_softwareVersion = g_softwareVersion;
  }
  
  private static long g_FactoryIdFlag = 3L;
  
  public static long getG_FactoryIdFlag() {
    return g_FactoryIdFlag;
  }
  
  public static void setG_FactoryIdFlag(long g_FactoryIdFlag) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_FactoryIdFlag = g_FactoryIdFlag;
  }
  
  public static long getG_HardwareModel() {
    return g_HardwareModel;
  }
  
  public static void setG_HardwareModel(long g_HardwareModel) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_HardwareModel = g_HardwareModel;
  }
  
  public static long getG_softwareModel() {
    return g_softwareModel;
  }
  
  public static void setG_softwareModel(long g_softwareModel) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_softwareModel = g_softwareModel;
  }
  
  public static long getG_HardwareVersion() {
    return g_HardwareVersion;
  }
  
  public static void setG_HardwareVersion(long g_HardwareVersion) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_HardwareVersion = g_HardwareVersion;
  }
  
  private static long g_start_sn = 0L;
  
  public static long getG_start_sn() {
    return g_start_sn;
  }
  
  public static void setG_start_sn(int g_start_sn) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_start_sn = g_start_sn;
  }
  
  private static long g_end_sn = -1L;
  
  public static long getG_end_sn() {
    return g_end_sn;
  }
  
  public static void setG_end_sn(long g_end_sn) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_end_sn = g_end_sn;
  }
  
  private int count = 0;
  
  private int countNit = 0;
  
  private int countPmt = 0;
  
  private int countUnt = 0;
  
  private static DbFrontEnd g_struFrontend;
  
  private static List<PartFile> g_struPartFile;
  
  private static short g_ulPartNum;
  
  public static DbFrontEnd getG_struFrontend() {
    return g_struFrontend;
  }
  
  public static void setG_struFrontend(DbFrontEnd g_struFrontend) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_struFrontend = g_struFrontend;
  }
  
  public static List<PartFile> getG_struPartFile() {
    return g_struPartFile;
  }
  
  public static void setG_struPartFile(List<PartFile> g_struPartFile) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_struPartFile = g_struPartFile;
  }
  
  public static short getG_ulPartNum() {
    return g_ulPartNum;
  }
  
  public static void setG_ulPartNum(int g_ulPartNum) {
    com.vendor.loader.util.ssu.SsusaTsPackageBuilder.g_ulPartNum = (short)g_ulPartNum;
  }
  
  private byte[] tempByte = new byte[6144];
  
  byte[] tsBuf = new byte[184];
  
  private byte[] validSDT = new byte[getTempByteLength()];
  
  private byte[] validNIT = new byte[getTempByteLength()];
  
  private byte[] validPMT = new byte[getTempByteLength()];
  
  byte[] pTmpPMT = new byte[4096];
  
  byte[] pTmpNIT = new byte[4096];
  
  private long transport_stream_id = 0L;
  
  private long original_network_id = 0L;
  
  private long service_id = 0L;
  
  private boolean isExistSDT = false;
  
  private boolean isExistNIT = false;
  
  private boolean isExistPMT = false;
  
  private boolean isFirstNIT = false;
  
  private int nitLength = 0;
  
  private int pmtLength = 0;
  
  private boolean isFirstPMT = false;
  
  private int numberUpgradeFile = 1;
  
  HeadTsPacket strHeadTsPak = new HeadTsPacket();
  
  HeadTsPacket nitHeadTsPak = new HeadTsPacket();
  
  HeadTsPacket untHeadTsPak = new HeadTsPacket();
  
  DSMCC_SectionInfo stNITSection = new DSMCC_SectionInfo();
  
  public IStatus createPackageOptions(List<UpgradeFileInfo> list, UpgradeInfo upInfo, SsuPackageOptions packageOtions, String strFilePathName, IProgressMonitor monitor) throws IOException, LoaderException {
    return null;
  }
  
  public IStatus createPackage(List<UpgradeFileInfo> oldlist, SsuUpgradeInfo upInfo, SsuPackageOptions packageOtions, String PathName, IProgressMonitor monitor) throws IOException, LoaderException {
    String strFilePathName = PathName + ".temp";
    monitor.setTaskName("Analysis of the part file");
    if (oldlist.size() != 2)
      return Status.CANCEL_STATUS; 
    monitor.setTaskName("Validate upgrade file list..");
    if (monitor.isCanceled())
      FileUtil.deleteFile(strFilePathName); 
    FileHelper.addFileLenth(oldlist);
    UpgradeFileInfo info = oldlist.get(1);
    long updateLength = info.getFileLength();
    List<UpgradeFileInfo> list = new ArrayList<>();
    if (updateLength > 260177920L) {
      long tempUpdataFileNumber = (updateLength % 260177920L == 0L) ? (updateLength / 260177920L) : (updateLength / 260177920L + 1L);
      String updateFileName = info.getFileName();
      RandomAccessFile updateFileRandomAccessFile = null;
      RandomFileOutputStream tempUpdateFileName = null;
      long pos = 0L;
      for (int i = 0; i < tempUpdataFileNumber; i++) {
        try {
          long totalLength = 260177920L;
          if (i == tempUpdataFileNumber - 1L)
            totalLength = updateLength - 260177920L * (tempUpdataFileNumber - 1L); 
          updateFileRandomAccessFile = new RandomAccessFile(new File(updateFileName), "r");
          String updateTempFileName = updateFileName + updateFileName;
          tempUpdateFileName = newOutputStream(updateTempFileName);
          UpgradeFileInfo tempInfo = new UpgradeFileInfo();
          tempInfo.setFileName(updateTempFileName);
          tempInfo.setFileLength(totalLength);
          list.add(tempInfo);
          long byteNumber = totalLength / 40660L;
          long lastByteLength = totalLength - byteNumber * 40660L;
          if (lastByteLength != 0L)
            byteNumber++; 
          byte[] tempData = new byte[40660];
          for (int j = 0; j < byteNumber; j++) {
            updateFileRandomAccessFile.seek(pos);
            if (j == byteNumber - 1L && lastByteLength > 0L) {
              tempData = new byte[(int)lastByteLength];
              pos += lastByteLength;
            } else {
              pos += 40660L;
            } 
            int readLength = updateFileRandomAccessFile.read(tempData, 0, tempData.length);
            if (tempUpdateFileName != null) {
              tempUpdateFileName.write(tempData, 0, readLength);
              tempUpdateFileName.flush();
            } 
          } 
          if (monitor.isCanceled()) {
            FileUtil.deleteFile(strFilePathName);
            return Status.CANCEL_STATUS;
          } 
          closeStream(PathName, monitor, strFilePathName, updateFileRandomAccessFile, tempUpdateFileName);
        } finally {
          closeStream(PathName, monitor, strFilePathName, updateFileRandomAccessFile, tempUpdateFileName);
        } 
      } 
    } else {
      list.add(oldlist.get(1));
    } 
    monitor.beginTask("Analysis of the part file", 100 * list.size() + 20 + 20);
    if (LoaderView.isETSITS102006V141()) {
      setG_softwareModel(upInfo.getSoftwareMode());
      setG_HardwareModel(upInfo.getHardwareMode());
    } 
    setG_softwareVersion(upInfo.getSoftwareVersion());
    setG_FactoryIdFlag(upInfo.getManufacturerId());
    setG_HardwareVersion(upInfo.getHardwareVersion());
    setG_start_sn(upInfo.getStartSn());
    setG_end_sn(upInfo.getEndSn());
    setG_struFrontend(new DbFrontEnd());
    getG_struFrontend().setU32Frequency(674000);
    getG_struFrontend().setU32SymbolRate(6875000);
    getG_struFrontend().setEnModulation(CableMode.valueOf(2));
    getG_struFrontend().setU16TsPID((short)upInfo.getDownloadPid());
    getG_struFrontend().setU16GroupID((short)upInfo.getDownloadGroupId());
    setG_u32GroupId(getG_struFrontend().getU16GroupID());
    if (monitor.isCanceled()) {
      FileUtil.deleteFile(strFilePathName);
      return Status.CANCEL_STATUS;
    } 
    monitor.worked(5);
    byte[] tsBuf = new byte[184];
    int lenDatagram = 0, lenPartInfo = 0, lenDownloadCtrl = 0;
    int pTempOffset = 0;
    DSMCC_SectionInfo stDSISection = new DSMCC_SectionInfo();
    DSMCC_SectionInfo stDIISection = new DSMCC_SectionInfo();
    int dataGramIndex = 0;
    this.strHeadTsPak.setSynByte((byte)71);
    this.strHeadTsPak.setTransportErrorIndicator1((byte)0);
    this.strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    this.strHeadTsPak.setTransportPriority1((byte)0);
    this.strHeadTsPak.setTransportScramblingControl2((byte)0);
    this.strHeadTsPak.setAdaptationFieldControl2((byte)1);
    this.nitHeadTsPak.setSynByte((byte)71);
    this.nitHeadTsPak.setTransportErrorIndicator1((byte)0);
    this.nitHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    this.nitHeadTsPak.setTransportPriority1((byte)0);
    this.nitHeadTsPak.setTransportScramblingControl2((byte)0);
    this.nitHeadTsPak.setAdaptationFieldControl2((byte)1);
    this.nitHeadTsPak.setPid13((short)16);
    this.untHeadTsPak.setSynByte((byte)71);
    this.untHeadTsPak.setTransportErrorIndicator1((byte)0);
    this.untHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    this.untHeadTsPak.setTransportPriority1((byte)0);
    this.untHeadTsPak.setTransportScramblingControl2((byte)0);
    this.untHeadTsPak.setAdaptationFieldControl2((byte)1);
    this.untHeadTsPak.setPid13((short)1500);
    Arrays.fill(tsBuf, (byte)-1);
    RandomFileOutputStream tempFp = newOutputStream(strFilePathName);
    if (tempFp == null)
      return Status.CANCEL_STATUS; 
    try {
      monitor.worked(5);
      monitor.setTaskName("Compute all of part file crc");
      setG_struPartFile(fillFileDataStruct(list));
      setG_ulPartNum(getG_struPartFile().size());
      monitor.setTaskName("Package Part file..");
      if (monitor.isCanceled()) {
        FileUtil.deleteFile(strFilePathName);
        return Status.CANCEL_STATUS;
      } 
      monitor.worked(10);
      for (int partIndex = 0; partIndex < getG_ulPartNum(); partIndex++) {
        if (monitor.isCanceled()) {
          FileUtil.deleteFile(strFilePathName);
          return Status.CANCEL_STATUS;
        } 
        PartFile partFile = getG_struPartFile().get(partIndex);
        long[] values = { partFile.getSectionNum(), partFile.getLastDiagramDataLength(), partFile.getDatagramNum() };
        this.strHeadTsPak.setPid13(getG_struFrontend().getU16TsPID());
        monitor.worked(20);
        long u16DataGramNum = values[0];
        SubProgressMonitor subProgressMonitor = null;
      } 
    } finally {
      monitor.worked(20);
      try {
        tempFp.close();
      } catch (IOException iOException) {}
      if (monitor.isCanceled()) {
        FileUtil.deleteFile(strFilePathName);
        FileUtil.deleteFile(PathName);
      } 
    } 
    if (list.size() > 1)
      for (int i = 0; i < list.size(); i++) {
        UpgradeFileInfo tempFileInfo = list.get(i);
        File file = new File(tempFileInfo.getFileName());
        if (file.exists())
          FileUtil.deleteFile(file); 
      }  
    return insertDate(strFilePathName, PathName, oldlist, monitor, upInfo, packageOtions);
  }
  
  private void closeStream(String PathName, IProgressMonitor monitor, String strFilePathName, RandomAccessFile updateFileRandomAccessFile, RandomFileOutputStream tempUpdateFileName) {
    try {
      if (updateFileRandomAccessFile != null)
        updateFileRandomAccessFile.close(); 
    } catch (IOException iOException) {}
    try {
      if (tempUpdateFileName != null)
        tempUpdateFileName.close(); 
    } catch (IOException iOException) {}
    if (monitor.isCanceled()) {
      FileUtil.deleteFile(strFilePathName);
      FileUtil.deleteFile(PathName);
    } 
  }
  
  static byte[] ssuaTempSectionData = new byte[getTempByteBufferLength()];
  
  private IStatus insertDate(String tempPathName, String strFilePathName, List<UpgradeFileInfo> oldlist, IProgressMonitor monitor, SsuUpgradeInfo info, SsuPackageOptions packageOtions) {
    monitor.beginTask("Packaged part files", 100 * oldlist.size() + 20 + 20);
    List<PartFile> partFiles = getSections(oldlist, tempPathName);
    RandomFileOutputStream fp = null;
    try {
      fp = newOutputStream(strFilePathName);
      if (fp == null)
        return Status.CANCEL_STATUS; 
      monitor.worked(30);
      insertData(partFiles);
      if (monitor.isCanceled())
        return Status.CANCEL_STATUS; 
      boolean isExist = (this.isExistSDT && this.isExistNIT && this.isExistPMT);
      if (!isExist)
        return (IStatus)new Status(8, "unknownId", 1, Messages.TsError, null); 
      createETSITSProtocol();
      boolean result = insertData(partFiles, info, fp, monitor, packageOtions);
      if (!result)
        return Status.CANCEL_STATUS; 
      File file = new File(tempPathName);
      if (file.exists() && 
        file.delete())
        return Status.OK_STATUS; 
    } catch (FileNotFoundException e) {
      return Status.CANCEL_STATUS;
    } catch (LoaderException e) {
      return Status.CANCEL_STATUS;
    } finally {
      try {
        if (fp != null)
          fp.close(); 
      } catch (IOException iOException) {}
      if (monitor.isCanceled()) {
        FileUtil.deleteFile(strFilePathName);
        FileUtil.deleteFile(tempPathName);
      } 
    } 
    return Status.OK_STATUS;
  }
  
  public void insertData(List<PartFile> partFiles) {
    PartFile partFile = partFiles.get(0);
    for (int i = 0; i < partFile.getSectionNum(); i++) {
      long u32DataLen;
      if (partFile.getSectionNum() - 1L == i) {
        u32DataLen = partFile.getLastDiagramDataLength();
      } else {
        u32DataLen = getTempByteBufferLength();
      } 
      RandomAccessFile file = null;
    } 
  }
  
  private void createETSITSProtocol() {
    byte[] transportStreamIdByte = new byte[2];
    transportStreamIdByte[0] = this.validSDT[8];
    transportStreamIdByte[1] = this.validSDT[9];
    this.transport_stream_id = convertString(transportStreamIdByte);
    int nitNetworkLength = this.validNIT[14] & 0xFF;
    int nextLength = 15 + nitNetworkLength + 2 - 1;
    int nitTransport_stream_loop_length = this.validNIT[nextLength] & 0xFF;
    byte[] cutTransport_stream_id = new byte[2];
    cutTransport_stream_id[0] = this.validNIT[nextLength + 1];
    cutTransport_stream_id[1] = this.validNIT[nextLength + 2];
    boolean isExest = false;
    long temp_transport_stream_id = convertString(cutTransport_stream_id);
    byte[] orignal_network_id = new byte[2];
    if (this.transport_stream_id == temp_transport_stream_id) {
      orignal_network_id[0] = this.validNIT[nextLength + 3];
      orignal_network_id[1] = this.validNIT[nextLength + 4];
      this.original_network_id = convertString(orignal_network_id);
      isExest = true;
    } 
    int transport_descriptors_length = this.validNIT[nextLength + 6];
    if (!isExest) {
      int size = 6;
      while (nitTransport_stream_loop_length - transport_descriptors_length + size > 0) {
        nextLength = transport_descriptors_length + 6 + nextLength;
        cutTransport_stream_id[0] = this.validNIT[nextLength + 1];
        cutTransport_stream_id[1] = this.validNIT[nextLength + 2];
        temp_transport_stream_id = convertString(cutTransport_stream_id);
        if (this.transport_stream_id == temp_transport_stream_id) {
          orignal_network_id[0] = this.validNIT[nextLength + 3];
          orignal_network_id[1] = this.validNIT[nextLength + 4];
          this.original_network_id = convertString(orignal_network_id);
          isExest = true;
        } 
        transport_descriptors_length += this.validNIT[nextLength + 6];
        size += 6;
      } 
    } 
    byte[] tempServiceId = new byte[2];
    tempServiceId[0] = this.validPMT[8];
    tempServiceId[1] = this.validPMT[9];
    this.service_id = convertString(tempServiceId);
  }
  
  private boolean insertData(List<PartFile> partFiles, SsuUpgradeInfo info, RandomFileOutputStream fp, IProgressMonitor monitor, SsuPackageOptions packageOtions) {
    this.numberUpgradeFile = packageOtions.getNumberUpgradeFile();
    long u32DataLen = 0L;
    PartFile tsPartFile = partFiles.get(0);
    PartFile updatePartFile = partFiles.get(1);
    long tsSectionNum = tsPartFile.getSectionNum();
    long sumUpgradeSectionNumber = updatePartFile.getSectionNum() * this.numberUpgradeFile;
    int packNumber = (int)(tsSectionNum / sumUpgradeSectionNumber);
    if (packNumber == 0)
      packNumber = 1; 
    int validOffsetIndext = 0;
    RandomAccessFile file = null;
    try {
      file = new RandomAccessFile(new File(tsPartFile.getFileName()), "r");
      validOffsetIndext = validOffset(file, getTempByteBufferLength());
    } catch (FileNotFoundException fileNotFoundException) {
    
    } catch (IOException iOException) {
    
    } finally {
      if (file != null)
        try {
          file.close();
        } catch (IOException iOException) {} 
    } 
    int index = 0;
    for (int i = 0; i < tsPartFile.getSectionNum(); i++) {
      if (tsPartFile.getSectionNum() - 1L == i) {
        u32DataLen = tsPartFile.getLastDiagramDataLength();
      } else {
        u32DataLen = getTempByteBufferLength();
      } 
      try {
        file = new RandomAccessFile(new File(tsPartFile.getFileName()), "r");
        long dataGramIndex = i;
        long srcOffset = dataGramIndex * getTempByteBufferLength() + validOffsetIndext;
        file.seek(srcOffset);
        int readLength = file.read(ssuaTempSectionData, 0, (int)u32DataLen);
        processingSection(fp, readLength, 0, ssuaTempSectionData, info);
        if (i % packNumber == 0 && this.numberUpgradeFile > 0)
          index = insertUpgradeFile(updatePartFile, fp, index); 
      } catch (Exception exception) {
      
      } finally {
        if (file != null)
          try {
            file.close();
          } catch (IOException iOException) {} 
      } 
      if (monitor.isCanceled())
        return false; 
      monitor.worked(80);
    } 
    return true;
  }
  
  private int insertUpgradeFile(PartFile tsPartFile, RandomFileOutputStream fp, int index) {
    if (index == tsPartFile.getSectionNum()) {
      index = 0;
      this.numberUpgradeFile--;
    } 
    RandomAccessFile file = null;
    try {
      long u32DataLen = 0L;
      if (index < tsPartFile.getSectionNum()) {
        if (tsPartFile.getSectionNum() - 1L == index) {
          u32DataLen = tsPartFile.getLastDiagramDataLength();
        } else {
          u32DataLen = getTempByteBufferLength();
        } 
        file = new RandomAccessFile(new File(tsPartFile.getFileName()), "r");
        long dataGramIndex = index;
        long srcOffset = dataGramIndex * getTempByteBufferLength();
        file.seek(srcOffset);
        int readLength = file.read(ssuaTempSectionData, 0, (int)u32DataLen);
        fp.write(ssuaTempSectionData, 0, readLength);
        index++;
      } 
    } catch (IOException iOException) {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException1) {}
    } finally {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException) {}
    } 
    return index;
  }
  
  private void isValid(int u32DataLen, byte[] ssuaTempSectionData) {
    byte[] tsStreamByte = new byte[getTempByteLength()];
    int number = u32DataLen / getTempByteLength();
    int lastSectionLength = getTempByteLength();
    if (0 != u32DataLen % getTempByteLength())
      lastSectionLength = u32DataLen % getTempByteLength(); 
    for (int i = 0; i < number; i++) {
      System.arraycopy(ssuaTempSectionData, i * getTempByteLength(), tsStreamByte, 0, lastSectionLength);
      long pid = convertString(tsStreamByte);
      if (pid >= 0L && pid <= 8190L)
        if (!this.isExistSDT && 
          isSDT(pid, tsStreamByte[5])) {
          System.arraycopy(tsStreamByte, 0, this.validSDT, 0, lastSectionLength);
          this.isExistSDT = true;
        } else if (!this.isExistNIT && 
          isNIT(pid, tsStreamByte[5])) {
          System.arraycopy(tsStreamByte, 0, this.validNIT, 0, lastSectionLength);
          this.isExistNIT = true;
        } else if (!this.isExistPMT && 
          isPMT(pid, tsStreamByte[5], tsStreamByte[6], tsStreamByte[10])) {
          System.arraycopy(tsStreamByte, 0, this.validPMT, 0, lastSectionLength);
          this.isExistPMT = true;
        }  
    } 
  }
  
  private void processingSection(RandomFileOutputStream fp, int u32DataLen, int index, byte[] ssuaTempSectionData, SsuUpgradeInfo info) throws IOException {
    byte[] tsStreamByte = new byte[getTempByteLength()];
    int number = u32DataLen / getTempByteLength();
    int lastSectionLength = getTempByteLength();
    if (0 != u32DataLen % getTempByteLength())
      lastSectionLength = u32DataLen % getTempByteLength(); 
    for (int i = 0; i < number; i++) {
      System.arraycopy(ssuaTempSectionData, i * getTempByteLength(), tsStreamByte, 0, lastSectionLength);
      long pid = convertString(tsStreamByte);
      if (pid >= 0L && pid <= 8190L) {
        if (isPMT(pid, tsStreamByte[5], tsStreamByte[6], tsStreamByte[10])) {
          Arrays.fill(this.pTmpPMT, (byte)-1);
          System.arraycopy(tsStreamByte, 0, this.pTmpPMT, this.pmtLength, tsStreamByte.length);
          int length = getTempByteLength();
          this.pmtLength += length;
          int sctionNumber = ((tsStreamByte[6] & 0xF) << 8) + (tsStreamByte[7] & 0xFF);
          if (sctionNumber + 8 - this.pmtLength > 0) {
            this.isFirstPMT = true;
          } else {
            createNewPmt(fp, info, tsStreamByte, lastSectionLength);
          } 
        } else if (this.isFirstPMT) {
          System.arraycopy(tsStreamByte, 3, this.pTmpPMT, this.pmtLength, tsStreamByte.length - 4);
          int length = getTempByteLength();
          this.pmtLength += length;
          int sectionLength = ((tsStreamByte[6] & 0xF) << 8) + (tsStreamByte[7] & 0xFF);
          if (sectionLength + 8 - this.pmtLength <= 0) {
            this.isFirstPMT = false;
            createNewPmt(fp, info, tsStreamByte, lastSectionLength);
            continue;
          } 
        } 
        if (isNIT(pid, tsStreamByte[5])) {
          if (tsStreamByte[1] >> 4 == 4) {
            Arrays.fill(this.pTmpNIT, (byte)-1);
            System.arraycopy(tsStreamByte, 0, this.pTmpNIT, this.nitLength, tsStreamByte.length);
            int length = getTempByteLength();
            this.nitLength += length;
            int sctionNumber = ((tsStreamByte[6] & 0xF) << 8) + (tsStreamByte[7] & 0xFF);
            if (sctionNumber + 8 - this.nitLength > 0) {
              this.isFirstNIT = true;
            } else {
              createNit(fp, info);
            } 
          } else if (this.isFirstNIT) {
            System.arraycopy(tsStreamByte, 3, this.pTmpNIT, this.nitLength, tsStreamByte.length - 4);
            int length = getTempByteLength();
            this.nitLength += length;
            int sectionLength = ((tsStreamByte[6] & 0xF) << 8) + (tsStreamByte[7] & 0xFF);
            if (sectionLength + 8 - this.nitLength <= 0)
              createNit(fp, info); 
          } 
          continue;
        } 
      } 
      fp.write(tsStreamByte, 0, lastSectionLength);
      fp.flush();
      continue;
    } 
  }
  
  private void createNewPmt(RandomFileOutputStream fp, SsuUpgradeInfo info, byte[] tsStreamByte, int lastSectionLength) throws IOException {
    this.pmtLength = 0;
    byte[] temp_service_id = new byte[2];
    temp_service_id[0] = tsStreamByte[8];
    temp_service_id[1] = tsStreamByte[9];
    long temp_service_id_valid = convertString(temp_service_id);
    if (temp_service_id_valid == this.service_id) {
      byte[] pTmp = new byte[getTempByteLength() * 2];
      int temp_length = ((tsStreamByte[6] & 0xF) << 8) + (tsStreamByte[7] & 0xFF);
      int temp_Insert_Index = temp_length + 4;
      System.arraycopy(tsStreamByte, 0, pTmp, 0, temp_Insert_Index);
      byte[] newPMT = createAndroidComponentsStream((UpgradeInfo)info);
      if (LoaderView.isETSITS102006V141())
        newPMT = createComponentsStreamV141((UpgradeInfo)info); 
      temp_length += newPMT.length;
      pTmp[6] = (byte)((byte)(temp_length & 0xF00) & 0xF);
      pTmp[7] = (byte)(temp_length & 0xFF);
      System.arraycopy(newPMT, 0, pTmp, temp_Insert_Index, newPMT.length);
      int crc = Crc32.compute(pTmp, 5, (pTmp[7] & 0xFF) - 1);
      alterU32ToU8(pTmp, (pTmp[7] & 0xFF) + 8 - 4, crc);
      int pTempOffset = 0;
      Arrays.fill(this.tempByte, (byte)-1);
      int sectionLength = ((pTmp[6] & 0xF) << 8) + (pTmp[7] & 0xFF);
      int lenDatagram = sectionLength + 1 + 8;
      try {
        int[] temp = fillTsPackage(this.tempByte, this.nitHeadTsPak, pTmp, pTempOffset, lenDatagram, this.countPmt, this.tsBuf, 16L);
        this.countNit = temp[0];
        int len = temp[1];
        try {
          fp.write(pTmp, 0, len);
        } catch (IOException e) {
          closeStream(fp);
          throw new LoaderException(Messages.TsPackageBuilder_CreateError);
        } 
        fflush(fp);
      } catch (LoaderException loaderException) {}
      if (LoaderView.isETSITS102006V141() && UpgradeInfo.UpgradeMode.ENHANCE == info.getUpgradeMode()) {
        byte[] pUntTmp = createUnt(info);
        fp.write(pUntTmp, 0, getTempByteLength());
        fp.flush();
      } 
    } else {
      fp.write(tsStreamByte, 0, lastSectionLength);
      fp.flush();
    } 
  }
  
  private void createNit(RandomFileOutputStream fp, SsuUpgradeInfo info) throws IOException {
    this.nitLength = 0;
    this.isFirstNIT = false;
    byte[] newNit = createAndroidNewNit((UpgradeInfo)info, this.transport_stream_id, this.original_network_id, this.service_id);
    if (LoaderView.isETSITS102006V141())
      newNit = createAndroidNewNitV141((UpgradeInfo)info, this.transport_stream_id, this.original_network_id, this.service_id); 
    int originalSectionLength = ((this.pTmpNIT[6] & 0xF) << 8) + (this.pTmpNIT[7] & 0xFF);
    int sectionLength = (originalSectionLength & 0xFFF) + newNit.length;
    this.pTmpNIT[6] = (byte)((sectionLength >> 4 << 4) + this.pTmpNIT[6] & 0xF);
    this.pTmpNIT[7] = (byte)(sectionLength & 0xFF);
    int originalNetworkDescriptorsPositionLength = this.pTmpNIT[14] & 0xFF;
    this.pTmpNIT[14] = (byte)(originalNetworkDescriptorsPositionLength + newNit.length);
    int insertAdd = 15 + originalNetworkDescriptorsPositionLength;
    int originalDataLength = originalSectionLength - originalNetworkDescriptorsPositionLength - 7 - 4;
    byte[] originalData = new byte[originalDataLength];
    System.arraycopy(this.pTmpNIT, insertAdd, originalData, 0, originalDataLength);
    System.arraycopy(newNit, 0, this.pTmpNIT, insertAdd, newNit.length);
    System.arraycopy(originalData, 0, this.pTmpNIT, insertAdd + newNit.length, originalData.length);
    int crc = Crc32.compute(this.pTmpNIT, 1, sectionLength + 1 - 4);
    int lenDatagram = sectionLength + 1 + 8 - 4;
    alterU32ToU8(this.pTmpNIT, lenDatagram, crc);
    lenDatagram += 4;
    int pTempOffset = 0;
    try {
      Arrays.fill(this.tempByte, (byte)-1);
      int[] temp = fillTsPackage(this.tempByte, this.nitHeadTsPak, this.pTmpNIT, pTempOffset, lenDatagram, this.countNit, this.tsBuf, 16L);
      this.countNit = temp[0];
      int len = temp[1];
      try {
        fp.write(this.tempByte, 0, len);
      } catch (IOException e) {
        closeStream(fp);
        throw new LoaderException(Messages.TsPackageBuilder_CreateError);
      } 
      fflush(fp);
    } catch (LoaderException loaderException) {}
  }
  
  private byte[] createUnt(SsuUpgradeInfo info) {
    byte[] nit = new byte[188];
    Arrays.fill(nit, (byte)-1);
    try {
      int linkageOffset = 4;
      createTsPackage(nit, this.untHeadTsPak, this.countUnt);
      nit[linkageOffset++] = 0;
      nit[linkageOffset++] = 75;
      nit[linkageOffset++] = -16;
      nit[linkageOffset++] = 0;
      nit[linkageOffset++] = 1;
      nit[linkageOffset++] = -1;
      nit[linkageOffset++] = -63;
      nit[linkageOffset++] = 0;
      nit[linkageOffset++] = 0;
      linkageOffset = alterU24ToU8(nit, linkageOffset, info.getManufacturerId());
      nit[linkageOffset++] = 0;
      linkageOffset = createCommonDescriptor(nit, linkageOffset);
      linkageOffset = createCompatibilityDescriptor(info, nit, linkageOffset);
      linkageOffset = alterU16ToU8(nit, linkageOffset, (short)0);
      nit[7] = (byte)(linkageOffset - 8 + 4 + 1);
      int len = nit[7] - 1;
      int crc = Crc32.compute(nit, 5, len);
      alterU32ToU8(nit, nit[7] + 8 - 4, crc);
    } catch (LoaderException loaderException) {}
    return nit;
  }
  
  private int createCommonDescriptor(byte[] nit, int linkageOffset) {
    nit[linkageOffset++] = -16;
    nit[linkageOffset++] = 6;
    nit[linkageOffset++] = 3;
    nit[linkageOffset++] = 4;
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)10);
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)90);
    return linkageOffset;
  }
  
  private int createCompatibilityDescriptor(SsuUpgradeInfo info, byte[] nit, int linkageOffset) {
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)28);
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)2);
    nit[linkageOffset++] = 1;
    nit[linkageOffset++] = 11;
    nit[linkageOffset++] = 1;
    linkageOffset = alterU24ToU8(nit, linkageOffset, info.getManufacturerId());
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)(info.getHardwareMode() & 0xFFFF));
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)(info.getHardwareVersion() & 0xFFFF));
    nit[linkageOffset++] = 2;
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)0);
    nit[linkageOffset++] = 2;
    nit[linkageOffset++] = 11;
    nit[linkageOffset++] = 1;
    linkageOffset = alterU24ToU8(nit, linkageOffset, info.getManufacturerId());
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)(info.getSoftwareMode() & 0xFFFF));
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)(info.getSoftwareVersion() & 0xFFFF));
    nit[linkageOffset++] = 2;
    linkageOffset = alterU16ToU8(nit, linkageOffset, (short)0);
    return linkageOffset;
  }
  
  private byte[] createComponentsStreamV141(UpgradeInfo info) {
    byte[] pTmp = new byte[44];
    int linkageOffset = 0;
    pTmp[linkageOffset++] = 13;
    if (info.getUpgradeMode() == UpgradeInfo.UpgradeMode.SIMPLE) {
      linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getDownloadPid() & 0x1FFE), 14);
    } else {
      linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)1500, 14);
    } 
    pTmp[linkageOffset++] = -16;
    pTmp[linkageOffset++] = 31;
    pTmp[linkageOffset++] = 102;
    pTmp[linkageOffset++] = 29;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)10);
    ComponentsOuiStream(info, pTmp, linkageOffset);
    return pTmp;
  }
  
  private void ComponentsOuiStream(UpgradeInfo info, byte[] pTmp, int linkageOffset) {
    pTmp[linkageOffset++] = 26;
    linkageOffset = alterU24ToU8(pTmp, linkageOffset, info.getManufacturerId());
    pTmp[linkageOffset++] = (byte)(info.getUpgradeMode().ordinal() + 1);
    pTmp[linkageOffset++] = 0;
    pTmp[linkageOffset++] = 20;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getHardwareVersion() & 0xFFFF));
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getHardwareMode() & 0xFFFF));
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getStartSn() & 0xFFFF));
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getEndSn() & 0xFFFF));
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    pTmp[linkageOffset++] = 11;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)info.getDownloadPid());
    pTmp[linkageOffset++] = -16;
    pTmp[linkageOffset++] = 3;
    pTmp[linkageOffset++] = 82;
    pTmp[linkageOffset++] = 1;
    pTmp[linkageOffset++] = 90;
  }
  
  private byte[] createAndroidComponentsStream(UpgradeInfo info) {
    byte[] pTmp = new byte[44];
    int linkageOffset = 0;
    pTmp[linkageOffset++] = 11;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)info.getDownloadPid());
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)39);
    pTmp[linkageOffset++] = 102;
    pTmp[linkageOffset++] = 37;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)10);
    pTmp[linkageOffset++] = 34;
    linkageOffset = alterU24ToU8(pTmp, linkageOffset, info.getManufacturerId());
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)0);
    pTmp[linkageOffset++] = 28;
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getHardwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getSoftwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getStartSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getEndSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    linkageOffset = alterU64ToU8(pTmp, linkageOffset, 0L);
    return pTmp;
  }
  
  private byte[] createAndroidNewNit(UpgradeInfo info, long transport_stream_id, long original_network_id, long service_id) {
    byte[] pTmp = new byte[42];
    int linkageOffset = 0;
    pTmp[linkageOffset++] = 74;
    pTmp[linkageOffset++] = 40;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(int)transport_stream_id);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(int)original_network_id);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(int)service_id);
    pTmp[linkageOffset++] = 9;
    pTmp[linkageOffset++] = 32;
    linkageOffset = alterU24ToU8(pTmp, linkageOffset, info.getManufacturerId());
    pTmp[linkageOffset++] = 28;
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getHardwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getSoftwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getStartSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info.getEndSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    linkageOffset = alterU64ToU8(pTmp, linkageOffset, 0L);
    return pTmp;
  }
  
  private byte[] createAndroidNewNitV141(UpgradeInfo info, long transport_stream_id, long original_network_id, long service_id) {
    byte[] pTmp = new byte[34];
    int linkageOffset = 0;
    pTmp[linkageOffset++] = 74;
    pTmp[linkageOffset++] = 32;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(int)transport_stream_id);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(int)original_network_id);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(int)service_id);
    pTmp[linkageOffset++] = 9;
    pTmp[linkageOffset++] = 24;
    linkageOffset = alterU24ToU8(pTmp, linkageOffset, info.getManufacturerId());
    pTmp[linkageOffset++] = 20;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getHardwareVersion() & 0xFFFF));
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getSoftwareVersion() & 0xFFFF));
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getStartSn() & 0xFFFF));
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)(info.getEndSn() & 0xFFFF));
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    linkageOffset = alterU64ToU8(pTmp, linkageOffset, 0L);
    return pTmp;
  }
  
  private static int alterU64ToU8(byte[] pu8Data, int offset, long u64Data) {
    pu8Data[offset] = (byte)(int)(u64Data >> 56L & 0xFFL);
    pu8Data[offset + 1] = (byte)(int)(u64Data >> 48L & 0xFFL);
    pu8Data[offset + 2] = (byte)(int)(u64Data >> 40L & 0xFFL);
    pu8Data[offset + 3] = (byte)(int)(u64Data >> 32L & 0xFFL);
    pu8Data[offset + 4] = (byte)(int)(u64Data >> 24L & 0xFFL);
    pu8Data[offset + 5] = (byte)(int)(u64Data >> 16L & 0xFFL);
    pu8Data[offset + 6] = (byte)(int)(u64Data >> 8L & 0xFFL);
    pu8Data[offset + 7] = (byte)(int)(u64Data & 0xFFL);
    offset += 8;
    return offset;
  }
  
  private static int validOffset(RandomAccessFile file, int byteLength) throws IOException {
    try {
      int index = 0;
      int readLength = byteLength;
      while (readLength == getTempByteBufferLength()) {
        byte[] tempArray = new byte[getTempByteBufferLength()];
        readLength = file.read(tempArray, index * getTempByteBufferLength(), getTempByteBufferLength());
        for (int i = 0; i < tempArray.length; i++) {
          if (tempArray[i] == 71 && tempArray[i + 
              getTempByteLength()] == 71)
            return i + index * ssuaTempSectionData.length; 
        } 
        index++;
      } 
      return -1;
    } finally {
      if (file != null)
        file.close(); 
    } 
  }
  
  private static int alterU24ToU8(byte[] pu8Data, int offset, int u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF0000) >>> 16);
    pu8Data[offset + 1] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 2] = (byte)(u32Data & 0xFF);
    return offset + 3;
  }
  
  private long convertString(byte[] src) {
    StringBuffer hex = new StringBuffer("0x");
    if (src.length > 10) {
      if (src[0] == 71) {
        byte[] newB = new byte[2];
        newB[0] = (byte)(src[1] & 0x1F);
        newB[1] = src[2];
        for (int i = 0; i < newB.length; i++)
          hex.append(Integer.toHexString(newB[i] & 0xFF)); 
        return StringUtil.convertString(hex.toString());
      } 
    } else if (src.length == 2) {
      byte[] newB = new byte[2];
      newB[0] = src[0];
      newB[1] = src[1];
      for (int i = 0; i < newB.length; i++)
        hex.append(Integer.toHexString(newB[i] & 0xFF)); 
      return StringUtil.convertString(hex.toString());
    } 
    return -1L;
  }
  
  private boolean isSDT(long pid, byte tableId) {
    if (pid == 17L && tableId == 66)
      return true; 
    return false;
  }
  
  private boolean isPMT(long pid, byte tableId, byte sectionSyntaxIndicator, byte currentNextIndicator) {
    if (pid >= 32L && pid <= 8190L && tableId == 2 && sectionSyntaxIndicator >> 4 == -5 && currentNextIndicator >> 7 == -1)
      return true; 
    return false;
  }
  
  private boolean isNIT(long pid, byte tableId) {
    if (pid == 16L)
      return true; 
    return false;
  }
  
  static byte[] tempSectionData = new byte[4066];
  
  private static void loadingDDBSectionData(DDBSections stDDBSections, PartFile partFile, int partIndex, int dataGramIndex, long[] values) {
    long u32DataLen = 0L;
    int u32TotleLen = 0;
    short u8LastSectionNum = 0;
    long sectionNum = values[0];
    long lastSectionLength = values[1];
    int u16ModuleId = partFile.getModuleId();
    short u8ModuleVersion = (short)partFile.getModuleVersion();
    RandomAccessFile file = null;
    try {
      file = new RandomAccessFile(new File(partFile.getFileName()), "r");
      stDDBSections.newDSMCC_SectionInfo(1);
      stDDBSections.setU16SectionNum((short)(int)sectionNum);
      if (sectionNum > 256L) {
        u8LastSectionNum = 0;
      } else {
        u8LastSectionNum = (short)(int)sectionNum;
      } 
      DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
      construct_DDBSecHead(stDSMCCHeader, (short)60, u16ModuleId, (short)(dataGramIndex % 256), u8LastSectionNum);
      if (sectionNum - 1L == dataGramIndex) {
        u32DataLen = lastSectionLength;
      } else {
        u32DataLen = 4066L;
      } 
      int u16MsgLen = (int)(6L + u32DataLen);
      DSMCCMessageHeader stDsmccMsgHeader = new DSMCCMessageHeader();
      u32TotleLen = 9 + stDsmccMsgHeader.getSize() + u16MsgLen + 4;
      stDDBSections.getpDDBSection()[0] = new DSMCC_SectionInfo();
      stDDBSections.getpDDBSection()[0].setpSectionBuff(new byte[u32TotleLen]);
      memset(stDDBSections.getpDDBSection()[0].getpSectionBuff(), 0, u32TotleLen);
      stDDBSections.getpDDBSection()[0].setBuffLength((short)u32TotleLen);
      stDSMCCHeader.setSection_length12((short)(u32TotleLen - 1 - 3));
      byte[] ptmp = stDDBSections.getpDDBSection()[0].getpSectionBuff();
      construct_SecHead(stDSMCCHeader, ptmp);
      int offset = 0;
      offset += 9;
      construct_DSMCCMessageHeader(ptmp, 4099, u16ModuleId, u16MsgLen, offset);
      offset += stDsmccMsgHeader.getSize();
      offset = alterU16ToU8(ptmp, offset, (short)u16ModuleId);
      ptmp[offset++] = (byte)u8ModuleVersion;
      offset++;
      offset = alterU16ToU8(ptmp, offset, (short)dataGramIndex);
      long srcOffset = dataGramIndex * 4066L;
      file.seek(srcOffset);
      int read = file.read(tempSectionData, 0, (int)u32DataLen);
      System.arraycopy(tempSectionData, 0, ptmp, offset, read);
      offset += read;
      int crc = Crc32.compute(stDDBSections.getpDDBSection()[0].getpSectionBuff(), 1, u32TotleLen - 1 - 4);
      alterU32ToU8(ptmp, offset, crc);
      offset += 4;
    } catch (IOException iOException) {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException1) {}
    } finally {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException) {}
    } 
  }
  
  private static void construct_DIISection(DSMCC_SectionInfo pDIISection, SsuUpgradeInfo upInfo) {
    DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
    DSMCCMessageHeader stDsmccMsgHeader = new DSMCCMessageHeader();
    int messageLen = 0;
    int downloadId = 0;
    if (LoaderView.isETSITS102006V141())
      downloadId = upInfo.getDownloadGroupId(); 
    short f = 0;
    ModuleDescription moduleDescription = new ModuleDescription();
    messageLen = 20 + getG_ulPartNum() * (moduleDescription.getSize() + 8 - 8) + 2;
    int totalLen = 9 + stDsmccMsgHeader.getSize() + messageLen + 4;
    pDIISection.setpSectionBuff(new byte[totalLen]);
    pDIISection.setBuffLength((short)totalLen);
    construct_DSIHead(stDSMCCHeader, 59, 0);
    stDSMCCHeader
      .setSection_length12((short)(totalLen - 1 - 3));
    byte[] pTmp = pDIISection.getpSectionBuff();
    construct_SecHead(stDSMCCHeader, pTmp);
    int offset = 0;
    offset += 9;
    construct_DSMCCMessageHeader(pTmp, 4098, getG_u32GroupId(), messageLen, offset);
    offset += stDsmccMsgHeader.getSize();
    offset = alterU32ToU8(pTmp, offset, downloadId);
    offset = alterU16ToU8(pTmp, offset, (short)4066);
    offset += 12;
    int numberOfModules = getG_ulPartNum();
    offset = alterU16ToU8(pTmp, offset, (short)numberOfModules);
    for (f = 0; f < getG_ulPartNum(); f = (short)(f + 1)) {
      ModuleDescription stModule = new ModuleDescription();
      stModule.setModuleId(((PartFile)getG_struPartFile().get(f)).getModuleId());
      stModule.setModuleSize(((PartFile)getG_struPartFile().get(f)).getFileSize());
      stModule.setModuleVersion(((PartFile)getG_struPartFile().get(f)).getModuleVersion());
      stModule.setModuleInfoLength((byte)(stModule.getModuleInfo().getSize() + 8 - 8));
      stModule.getModuleInfo().setFlashStartAddr(((PartFile)getG_struPartFile().get(f)).getBurnAddr());
      stModule.getModuleInfo().setFlashEndAddr(((PartFile)getG_struPartFile().get(f)).getuPartitionEndAddr());
      stModule.getModuleInfo().setFlashType(((PartFile)getG_struPartFile().get(f)).getuFlashType().ordinal());
      stModule.getModuleInfo().setFlashIndex(((PartFile)getG_struPartFile().get(f)).getlFlashIndex());
      stModule.getModuleInfo().setPartitionCRC(((PartFile)getG_struPartFile().get(f)).getCrcValue());
      construct_ModuleDescription(stModule, pTmp, offset);
      offset += stModule.getSize() + 8 - 8;
    } 
    int privateLength = 0;
    offset = alterU16ToU8(pTmp, offset, (short)privateLength);
    int crc = Crc32.compute(pDIISection.getpSectionBuff(), 1, totalLen - 1 - 4);
    alterU32ToU8(pTmp, offset, crc);
    offset += 4;
  }
  
  private static void construct_ModuleDescription(ModuleDescription pstModule, byte[] pTmp, int offset) {
    int descOffset = offset;
    descOffset = alterU16ToU8(pTmp, descOffset, pstModule.getModuleId());
    descOffset = alterU32ToU8(pTmp, descOffset, (int)pstModule.getModuleSize());
    pTmp[descOffset++] = pstModule.getModuleVersion();
    pTmp[descOffset++] = pstModule.getModuleInfoLength();
    descOffset = alterU32ToU8(pTmp, descOffset, (int)pstModule.getModuleInfo().getFlashStartAddr());
    descOffset = alterU32ToU8(pTmp, descOffset, (int)pstModule.getModuleInfo().getFlashEndAddr());
    descOffset = alterU32ToU8(pTmp, descOffset, pstModule.getModuleInfo().getFlashType());
    descOffset = alterU32ToU8(pTmp, descOffset, pstModule.getModuleInfo().getFlashIndex());
    descOffset = alterU32ToU8(pTmp, descOffset, pstModule.getModuleInfo().getPartitionCRC());
  }
  
  private static RandomFileOutputStream newOutputStream(String strFilePathName) throws FileNotFoundException, LoaderException {
    FileUtil.deleteFile(strFilePathName);
    if (!FileUtil.canWriteFile(strFilePathName, Messages.TsPackageBuilder_CreateError))
      return null; 
    RandomFileOutputStream fp = null;
    try {
      fp = new RandomFileOutputStream(strFilePathName);
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
    return fp;
  }
  
  public static void writeByte(byte[] src, int srcPos, byte[] dest, int destPos, int length) {
    System.arraycopy(src, srcPos, dest, destPos, length);
  }
  
  private static void construct_TsHead(byte[] out, HeadTsPacket pstrHeadTsPak, int destPos) throws LoaderException {
    byte[] headBuf = new byte[4];
    headBuf[0] = pstrHeadTsPak.getSynByte();
    headBuf[1] = 
      
      (byte)(0x0 | pstrHeadTsPak.getTransportErrorIndicator1() << 7 | pstrHeadTsPak.getPayloadUnitStartIndicator1() << 6 | pstrHeadTsPak.getTransportPriority1() << 5 | pstrHeadTsPak.getPid13() >>> 8 & 0x1F);
    headBuf[2] = (byte)(pstrHeadTsPak.getPid13() & 0xFF);
    headBuf[3] = 
      (byte)(0x0 | pstrHeadTsPak.getTransportScramblingControl2() << 6 | pstrHeadTsPak.getAdaptationFieldControl2() << 4 | pstrHeadTsPak.getContinuityCounter4());
    writeByte(headBuf, 0, out, destPos, headBuf.length);
  }
  
  private byte[] createTsPackage(byte[] fp, HeadTsPacket strHeadTsPak, int count) throws LoaderException {
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    construct_TsHead(fp, strHeadTsPak, 0);
    this.countUnt = count;
    return fp;
  }
  
  private static int[] fillTsPackage(byte[] fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf, long pid) throws LoaderException, IOException {
    int oldLen = 0;
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    construct_TsHead(fp, strHeadTsPak, 0);
    pTempOffset += 4;
    oldLen += 4;
    if (lenDownloadCtrl > 184) {
      while (lenDownloadCtrl > 184) {
        writeByte(pTmp, oldLen, fp, pTempOffset, 184);
        lenDownloadCtrl -= 184;
        oldLen += 184;
        strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
        if (count > 15)
          count = 0; 
        strHeadTsPak.setPayloadUnitStartIndicator1((byte)0);
        pTempOffset += 184;
        construct_TsHead(fp, strHeadTsPak, pTempOffset);
        pTempOffset += 4;
      } 
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } else {
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } 
    int[] temp = new int[2];
    temp[0] = count;
    temp[1] = pTempOffset;
    return temp;
  }
  
  private static int[] fillTsPackage(byte[] fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf) throws LoaderException, IOException {
    int oldLen = 0;
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    construct_TsHead(fp, strHeadTsPak, 0);
    pTempOffset += 4;
    if (lenDownloadCtrl > 184) {
      while (lenDownloadCtrl > 184) {
        writeByte(pTmp, oldLen, fp, pTempOffset, 184);
        lenDownloadCtrl -= 184;
        oldLen += 184;
        strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
        if (count > 15)
          count = 0; 
        if (strHeadTsPak.getPid13() != 8191)
          strHeadTsPak.setPayloadUnitStartIndicator1((byte)0); 
        pTempOffset += 184;
        construct_TsHead(fp, strHeadTsPak, pTempOffset);
        pTempOffset += 4;
      } 
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } else {
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } 
    int[] temp = new int[2];
    temp[0] = count;
    temp[1] = pTempOffset;
    return temp;
  }
  
  private static int fillTsPackage(RandomFileOutputStream fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf) throws LoaderException, IOException {
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    try {
      construct_TsHead((OutputStream)fp, strHeadTsPak);
      if (lenDownloadCtrl > 184) {
        while (lenDownloadCtrl > 184) {
          fp.write(pTmp, pTempOffset, 184);
          lenDownloadCtrl -= 184;
          strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
          if (count > 15)
            count = 0; 
          strHeadTsPak.setPayloadUnitStartIndicator1((byte)0);
          construct_TsHead((OutputStream)fp, strHeadTsPak);
          pTempOffset += 184;
        } 
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } else {
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } 
    } catch (IOException e) {
      closeStream(fp);
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
    fflush(fp);
    return count;
  }
  
  private static void fflush(RandomFileOutputStream fp) throws LoaderException {
    try {
      fp.flush();
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_CreateError + Messages.TsPackageBuilder_CreateError);
    } 
  }
  
  private static void closeStream(RandomFileOutputStream fp) {
    try {
      fp.close();
    } catch (IOException iOException) {}
  }
  
  private static void construct_DSMCCMessageHeader(byte[] pBuff, int msgId, int transactionId, int msgLen, int offset) {
    int descOffset = offset;
    DSMCCMessageHeader stMsgHeader = new DSMCCMessageHeader();
    stMsgHeader.setProtocolDiscriminator((byte)17);
    stMsgHeader.setDsmccType((byte)3);
    stMsgHeader.setMessageId((short)msgId);
    stMsgHeader.setTransactionId(transactionId);
    stMsgHeader.setReserved((byte)0);
    stMsgHeader.setAdapationLength((byte)0);
    stMsgHeader.setMessageLength((short)msgLen);
    pBuff[descOffset++] = stMsgHeader.getProtocolDiscriminator();
    pBuff[descOffset++] = stMsgHeader.getDsmccType();
    descOffset = alterU16ToU8(pBuff, descOffset, stMsgHeader.getMessageId());
    descOffset = alterU32ToU8(pBuff, descOffset, stMsgHeader.getTransactionId());
    pBuff[descOffset++] = stMsgHeader.getReserved();
    pBuff[descOffset++] = stMsgHeader.getAdapationLength();
    descOffset = alterU16ToU8(pBuff, descOffset, stMsgHeader.getMessageLength());
  }
  
  private static void memcpy(byte[] pu8Temp, int offset, byte[] downloadDescriptionString, short len) {
    System.arraycopy(downloadDescriptionString, 0, pu8Temp, offset, len);
  }
  
  private static void memset(byte[] buf, int value, int len) {
    assert buf.length == len;
    Arrays.fill(buf, (byte)value);
  }
  
  private static void construct_TsHead(OutputStream out, HeadTsPacket pstrHeadTsPak) throws LoaderException {
    byte[] headBuf = new byte[4];
    headBuf[0] = pstrHeadTsPak.getSynByte();
    headBuf[1] = 
      
      (byte)(0x0 | pstrHeadTsPak.getTransportErrorIndicator1() << 7 | pstrHeadTsPak.getPayloadUnitStartIndicator1() << 6 | pstrHeadTsPak.getTransportPriority1() << 5 | pstrHeadTsPak.getPid13() >>> 8 & 0x1F);
    headBuf[2] = (byte)(pstrHeadTsPak.getPid13() & 0xFF);
    headBuf[3] = 
      (byte)(0x0 | pstrHeadTsPak.getTransportScramblingControl2() << 6 | pstrHeadTsPak.getAdaptationFieldControl2() << 4 | pstrHeadTsPak.getContinuityCounter4());
    try {
      out.write(headBuf);
      out.flush();
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_FillError);
    } 
  }
  
  private static void construct_SecHead(DSMCCSectionHead pSecHead, byte[] secBuf) {
    secBuf[0] = 0;
    secBuf[1] = pSecHead.getTable_id();
    secBuf[2] = 
      (byte)(0x0 | pSecHead.getSection_syntax_indicator1() << 7 | 0x70 | (pSecHead.getSection_length12() & 0xF00) >> 8);
    secBuf[3] = (byte)(pSecHead.getSection_length12() & 0xFF);
    secBuf[4] = (byte)((pSecHead.getTable_id_extension() & 0xFF00) >> 8);
    secBuf[5] = (byte)(pSecHead.getTable_id_extension() & 0xFF);
    secBuf[6] = (byte)((pSecHead.getVersion_number5() & 0x1F) << 2 | pSecHead.getCurrent_next_indicator1());
    secBuf[7] = pSecHead.getSection_number();
    secBuf[8] = pSecHead.getLast_section_number();
  }
  
  private static int alterU32ToU8(byte[] pu8Data, int offset, int u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF000000) >>> 24);
    pu8Data[offset + 1] = (byte)((u32Data & 0xFF0000) >>> 16);
    pu8Data[offset + 2] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 3] = (byte)(u32Data & 0xFF);
    return offset + 4;
  }
  
  private static int alterU16ToU8(byte[] pu8Data, int offset, short u32Data, int hData) {
    pu8Data[offset] = (byte)(((u32Data & 0xFF00) >>> 8) + (hData << 12 >>> 8));
    pu8Data[offset + 1] = (byte)(u32Data & 0xFF);
    return offset + 2;
  }
  
  private static int alterU16ToU8(byte[] pu8Data, int offset, short u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 1] = (byte)(u32Data & 0xFF);
    return offset + 2;
  }
  
  private static void construct_DDBSecHead(DSMCCSectionHead stDSMCCHeader, short ddbTableId, int u16TableExId, short u8SectionNum, short last_section_number) {
    stDSMCCHeader.setTable_id((byte)ddbTableId);
    stDSMCCHeader.setSection_syntax_indicator1((byte)1);
    stDSMCCHeader.setTable_id_extension((short)u16TableExId);
    stDSMCCHeader.setCurrent_next_indicator1((byte)1);
    stDSMCCHeader.setVersion_number5((byte)0);
    stDSMCCHeader.setSection_number((byte)u8SectionNum);
    stDSMCCHeader.setLast_section_number((byte)last_section_number);
  }
  
  private static void construct_DSISection(DSMCC_SectionInfo pDSISection) {
    DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
    DSMCCMessageHeader stDsmccMsgHeader = new DSMCCMessageHeader();
    int u32CrcVal = 0;
    int crcDataLen = 0;
    byte[] serviceId = new byte[20];
    int privateLength = 0;
    pDSISection.setpSectionBuff(new byte[1024]);
    pDSISection.setBuffLength((short)0);
    pDSISection.setBuffLength(
        (short)(pDSISection.getBuffLength() + 8 + 1));
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + stDsmccMsgHeader.getSize()));
    memset(serviceId, 255, serviceId.length);
    memcpy(pDSISection.getpSectionBuff(), pDSISection.getBuffLength(), serviceId, (short)serviceId.length);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + serviceId.length));
    byte[] pTmp = pDSISection.getpSectionBuff();
    int offset = pDSISection.getBuffLength();
    int outCompatibility = 0;
    alterU16ToU8(pTmp, offset, (short)outCompatibility);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 2));
    offset = pDSISection.getBuffLength() + 2;
    privateLength = construct_GroupInfoIndication(pTmp, offset, privateLength);
    offset = pDSISection.getBuffLength();
    alterU16ToU8(pTmp, offset, (short)privateLength);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + privateLength + 2));
    int messageLen = privateLength + serviceId.length + 2 + 2;
    offset = 9;
    construct_DSMCCMessageHeader(pTmp, 4102, 0, messageLen, offset);
    stDSMCCHeader.setSection_length12((short)(5 + stDsmccMsgHeader.getSize() + messageLen + 4));
    construct_DSIHead(stDSMCCHeader, 59, 0);
    construct_SecHead(stDSMCCHeader, pDSISection.getpSectionBuff());
    crcDataLen = stDSMCCHeader.getSection_length12() + 3 - 4;
    u32CrcVal = Crc32.compute(pDSISection.getpSectionBuff(), 1, crcDataLen);
    alterU32ToU8(pDSISection.getpSectionBuff(), 1 + crcDataLen, u32CrcVal);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 4));
  }
  
  private static void construct_DSIHead(DSMCCSectionHead pSectionHead, int tableID, int tableIdExt) {
    pSectionHead.setTable_id((byte)tableID);
    pSectionHead.setSection_syntax_indicator1((byte)1);
    pSectionHead.setTable_id_extension((short)tableIdExt);
    pSectionHead.setVersion_number5((byte)0);
    pSectionHead.setCurrent_next_indicator1((byte)1);
    pSectionHead.setVersion_number5((byte)0);
    pSectionHead.setSection_number((byte)0);
    pSectionHead.setLast_section_number((byte)1);
  }
  
  static SubCompatibilityDescriptor subCompatibilityDescriptor = new SubCompatibilityDescriptor();
  
  private static int construct_GroupInfoIndication(byte[] pBuff, int offset, int pLen) {
    short f = 0;
    int descOffset = offset;
    GroupInfoIndication stGII = new GroupInfoIndication();
    int descpLen = 0;
    stGII.setNumberOfGroup((short)1);
    descOffset = alterU16ToU8(pBuff, descOffset, stGII.getNumberOfGroup());
    descpLen += 2;
    for (f = 0; f < stGII.getNumberOfGroup(); f = (short)(f + 1)) {
      stGII.getGroupDescription()[f] = new GroupDescription();
      stGII.getGroupDescription()[f].setGroupId(getG_u32GroupId());
      stGII.getGroupDescription()[f].setGroupSize(getG_u32DataTotalLen());
      descOffset = alterU32ToU8(pBuff, descOffset, stGII.getGroupDescription()[f].getGroupId());
      descOffset = alterU32ToU8(pBuff, descOffset, (int)stGII.getGroupDescription()[f].getGroupSize());
      descpLen += 8;
      CompatibilityDescriptor pstCompDes = stGII.getGroupDescription()[f].getGroupCompatibility();
      pstCompDes.setDescriptorCount((short)4);
      pstCompDes.setCompatibilityDescriptorLength(
          (short)((subCompatibilityDescriptor.getSize() - 4) * pstCompDes.getDescriptorCount() + 2));
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getCompatibilityDescriptorLength());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptorCount());
      descpLen += 4;
      pstCompDes.getDescriptor()[0] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[0].setDescriptorType((byte)1);
      pstCompDes.getDescriptor()[0].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[0].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[0].setSpecifierData((int)(getG_FactoryIdFlag() & 0xFFFFFFL));
      if (LoaderView.isETSITS102006V141()) {
        pstCompDes.getDescriptor()[0].setModel((short)(int)(getG_HardwareModel() & 0xFFFFL));
        pstCompDes.getDescriptor()[0].setVersion((short)(int)(getG_HardwareVersion() & 0xFFFFL));
      } else {
        pstCompDes.getDescriptor()[0].setModel((short)(int)((getG_HardwareVersion() & 0xFFFFFFFFFFFF0000L) >>> 16L));
        pstCompDes.getDescriptor()[0].setVersion((short)(int)(getG_HardwareVersion() & 0xFFFFL));
      } 
      pstCompDes.getDescriptor()[0].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[0].getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[0].getDescriptorLength();
      pBuff[descOffset++] = (byte)pstCompDes.getDescriptor()[0].getSpecifierType();
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[0].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[0].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = (byte)(pstCompDes.getDescriptor()[0].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[0].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[0].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[0].getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      pstCompDes.getDescriptor()[1] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[1].setDescriptorType((byte)2);
      pstCompDes.getDescriptor()[1].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[1].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[1].setSpecifierData((int)(getG_FactoryIdFlag() & 0xFFFFFFL));
      if (LoaderView.isETSITS102006V141()) {
        pstCompDes.getDescriptor()[1].setModel((short)(int)(getG_softwareModel() & 0xFFFFL));
        pstCompDes.getDescriptor()[1].setVersion((short)(int)(getG_softwareVersion() & 0xFFFFL));
      } else {
        pstCompDes.getDescriptor()[1].setModel((short)(int)((getG_softwareVersion() & 0xFFFFFFFFFFFF0000L) >>> 16L));
        pstCompDes.getDescriptor()[1].setVersion((short)(int)(getG_softwareVersion() & 0xFFFFL));
      } 
      pstCompDes.getDescriptor()[1].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[1].getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[1].getDescriptorLength();
      pBuff[descOffset++] = (byte)pstCompDes.getDescriptor()[1].getSpecifierType();
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[1].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[1].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = (byte)(pstCompDes.getDescriptor()[1].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[1].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[1].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[1].getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      pstCompDes.getDescriptor()[2] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[2].setDescriptorType((byte)64);
      pstCompDes.getDescriptor()[2].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[2].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[2].setSpecifierData((int)(getG_FactoryIdFlag() & 0xFFFFFFL));
      pstCompDes.getDescriptor()[2].setModel((short)(int)((getG_start_sn() & 0xFFFFFFFFFFFF0000L) >>> 16L));
      pstCompDes.getDescriptor()[2].setVersion((short)(int)(getG_start_sn() & 0xFFFFL));
      pstCompDes.getDescriptor()[2].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[2].getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[2].getDescriptorLength();
      pBuff[descOffset++] = (byte)pstCompDes.getDescriptor()[2].getSpecifierType();
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[2].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[2].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = (byte)(pstCompDes.getDescriptor()[2].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[2].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[2].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[2].getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      pstCompDes.getDescriptor()[3] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[3].setDescriptorType((byte)65);
      pstCompDes.getDescriptor()[3].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[3].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[3].setSpecifierData((int)(getG_FactoryIdFlag() & 0xFFFFFFL));
      pstCompDes.getDescriptor()[3].setModel((short)(int)((getG_end_sn() & 0xFFFFFFFFFFFF0000L) >>> 16L));
      pstCompDes.getDescriptor()[3].setVersion((short)(int)(getG_end_sn() & 0xFFFFL));
      pstCompDes.getDescriptor()[3].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[3].getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[3].getDescriptorLength();
      pBuff[descOffset++] = (byte)pstCompDes.getDescriptor()[3].getSpecifierType();
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[3].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = (byte)((pstCompDes.getDescriptor()[3].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = (byte)(pstCompDes.getDescriptor()[3].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[3].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes.getDescriptor()[3].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[3].getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      stGII.getGroupDescription()[f].setGoupInfoLength((short)0);
      descOffset = alterU16ToU8(pBuff, descOffset, stGII.getGroupDescription()[f].getGoupInfoLength());
      descpLen += 2;
      stGII.getGroupDescription()[f].setPrivateLength((short)0);
      descOffset = alterU16ToU8(pBuff, descOffset, stGII.getGroupDescription()[f].getPrivateLength());
      descpLen += 2;
    } 
    return descpLen;
  }
  
  public static void memcpy(byte[] pTmp, int offset, String string, long len) {
    if (len > string.length())
      len = string.length(); 
    for (int i = 0; i < len; i++)
      pTmp[offset++] = (byte)string.charAt(i); 
  }
  
  private List<PartFile> getSections(List<UpgradeFileInfo> files, String tempPathName) {
    List<PartFile> parts = new ArrayList<>();
    long u32DatagramNum = 0L;
    for (int i = 0; i < files.size(); i++) {
      PartFile partFile = new PartFile();
      String fileName = ((UpgradeFileInfo)files.get(i)).getFileName();
      if (i == 1)
        fileName = tempPathName; 
      long fileLength = (new File(fileName)).length();
      long lastSectionLength = getTempByteBufferLength();
      u32DatagramNum = fileLength / getTempByteBufferLength();
      if (0L != fileLength % getTempByteBufferLength()) {
        lastSectionLength = fileLength % getTempByteBufferLength();
        u32DatagramNum++;
      } 
      partFile.setLastDiagramDataLength(lastSectionLength);
      partFile.setSectionNum(u32DatagramNum);
      partFile.setFileName(fileName);
      parts.add(partFile);
    } 
    return parts;
  }
  
  private static int getTempByteBufferLength() {
    return 4136;
  }
  
  private static int getTempByteLength() {
    return 188;
  }
  
  private static List<PartFile> fillFileDataStruct(List<UpgradeFileInfo> files) {
    long u32DatagramNum = 0L;
    setG_u32DataTotalLen(0L);
    setG_u32DataCrc(-1);
    List<PartFile> headers = new ArrayList<>(files.size());
    for (int i = 0; i < files.size(); i++) {
      PartFile partFile = new PartFile();
      headers.add(partFile);
      partFile.init(files.get(i), getG_u32GroupId(), i);
      long fileLength = (new File(partFile.getFileName())).length();
      setG_u32DataTotalLen(getG_u32DataTotalLen() + fileLength);
      long lastSectionLength = 4066L;
      u32DatagramNum = fileLength / 4066L;
      if (0L != fileLength % 4066L) {
        lastSectionLength = fileLength % 4066L;
        u32DatagramNum++;
      } 
      partFile.setDatagramNum((int)u32DatagramNum);
      partFile.setLastDiagramDataLength(lastSectionLength);
      partFile.setSectionNum(u32DatagramNum);
      try {
        int[] crc = Crc32.compute(partFile.getFileName(), getG_u32DataCrc());
        partFile.setCrcValue(crc[0]);
        setG_u32DataCrc(crc[1]);
      } catch (IOException iOException) {}
    } 
    return headers;
  }
  
  public IStatus createPackage(List<UpgradeFileInfo> fileInfoList, UpgradeInfo info, String tsFileName, IProgressMonitor monitor) throws IOException, LoaderException {
    return null;
  }
}
